#include "stdafx.h"
#include ".\nptimer.h"

#include "NPSingleton.h"
/************************************************************************/
/* CTimerQueue */
/************************************************************************/
class CTimerQueue
{
public:
	CTimerQueue()
	{
		m_hTimerQueue = ::CreateTimerQueue();		
	}
	virtual ~CTimerQueue()
	{
		if (NULL != m_hTimerQueue)
		{
			::DeleteTimerQueue(m_hTimerQueue);
			m_hTimerQueue = NULL;
		}
	}
	HANDLE m_hTimerQueue;
};

inline HANDLE UFInternalGetTimerQueue()
{
	return CNPSingleton<CTimerQueue>::get_instance()->m_hTimerQueue;
}
HANDLE UFCreateTimerQueueTimer(WAITORTIMERCALLBACK pfnCallback, PVOID pParameter,DWORD dwDueTime, DWORD dwInterval, BOOL bRepeat, ULONG flags)
{
	HANDLE hTimer = NULL;

	if (!::CreateTimerQueueTimer(&hTimer, UFInternalGetTimerQueue(), pfnCallback, pParameter, dwDueTime, (bRepeat ? dwInterval : 0), flags))
		return NULL;

	return hTimer;
}

BOOL UFDeleteTimerQueueTimer(HANDLE hTimer, HANDLE hCompletionEvent)
{
	BOOL bSuccess = ::DeleteTimerQueueTimer(UFInternalGetTimerQueue(), hTimer, hCompletionEvent);
	return bSuccess;
}

BOOL UFChangeTimerQueueTimer(HANDLE hTimer, ULONG dueTime, ULONG period)
{
	BOOL bSuccess = ::ChangeTimerQueueTimer(UFInternalGetTimerQueue(), hTimer, dueTime, period);
	return bSuccess;
}
/************************************************************************/
/* CNPTimer */
/************************************************************************/
CNPTimer::CNPTimer(void)
{
	m_dwPeriod = 0;	
	m_hTimer = INVALID_HANDLE_VALUE;	
	m_dwTid = 0;	
	m_pHandler = NULL;
}

CNPTimer::~CNPTimer(void)
{
	StopTimer();
}
BOOL CNPTimer::SetTimer(DWORD dwStartDueTime, DWORD dwPeriod, DWORD dwTid, INPTimerHandler* pHandler, ULONG uFlag)
{
	(uFlag);
	BOOL bSuccess = FALSE;
	
	if (m_hTimer != INVALID_HANDLE_VALUE)
	{
		return TRUE;
	}
	m_dwPeriod = dwPeriod;
	m_dwTid = dwTid;
	m_pHandler = pHandler;
	m_hTimer = UFCreateTimerQueueTimer(fnCallback, this, dwStartDueTime, dwPeriod, TRUE, 0);

	bSuccess = ( NULL != m_hTimer );
	return bSuccess;
}
BOOL CNPTimer::StopTimer()
{	
	if (m_hTimer == INVALID_HANDLE_VALUE)
	{
		return TRUE;
	}
	BOOL bSuccess = UFDeleteTimerQueueTimer(m_hTimer, NULL);
	m_dwPeriod = 0;	
	m_hTimer = INVALID_HANDLE_VALUE;	
	m_dwTid = 0;	
	m_pHandler = NULL;
	
	return bSuccess;
}

VOID CALLBACK CNPTimer::fnCallback(PVOID pvContext, BOOLEAN TimerOrWaitFired)
{
	(TimerOrWaitFired);
	CNPTimer* pTimer = reinterpret_cast<CNPTimer*>(pvContext);

	if(pTimer)
	{		
		if (pTimer->IsAvailable())
		{
			pTimer->GetTimerHandler()->OnTimer( pTimer->GetTimerID());
		}
	}	
}